# Description:
#   A bread-based joke is told when bread co jargon is mentioned or when a joke is asked for
#
# Dependencies:
#   None
#
# Configuration:
#   HUBOT_BREAD_JARGON comma-separated list of additional triggers
#   HUBOT_BREAD_OMITTED_JARGON comma-separated list of triggers to ignore
#
# Commands:
#   Bread jargon - responds with bread joke
#   Pun Me - responds with bread joke
#
# Notes:
#   See jargon array for list of trigger phrases
#
# Author:
#   Tony Bologna <tonybolognbahead@gmail.com> (https://github.com/tmcnary)

jokes = require './data/jokes.json'
jargon = require './data/triggers.json'

removeTerm = (term, arrayToDeleteFrom) ->
  index = arrayToDeleteFrom.indexOf term
  if index > -1
    arrayToDeleteFrom.splice index, 1
  arrayToDeleteFrom

if process.env.HUBOT_BREAD_PUN_TRIGGERS?
  additionalJargon = (process.env.HUBOT_BREAD_PUN_TRIGGERS).split(',')
  jargon = jargon.concat(additionalJargon)

if process.env.HUBOT_BREAD_PUN_OMITTED_JARGON?
  omittedJargon = (process.env.HUBOT_BREAD_PUN_OMITTED_JARGON).split(',')
  jargon = removeTerm(term, jargon) for term in omittedJargon

regex = new RegExp jargon.join('|'), 'gi'

exports = module.exports = (robot) ->
  robot.hear regex, (msg) ->
    msg.send msg.random jokes

exports.removeTerm = removeTerm